#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* zadane parametry */  
int m,n,t1,t2,x1,y1,x2,y2;
        
/* teplota rybnika po radcich (indexovany od nuly!)*/
int *rybnik;
#define R(x,y) (rybnik[(x)+m*(y)])
        
void nacti(FILE *f)
{
        int i,j;
        fscanf(f,"%d %d %d %d",&m,&n,&t1,&t2);
        fscanf(f,"%d %d %d %d",&x1,&y1,&x2,&y2);
        /* prevod na cislovani od 0 */
        x1--;y1--;x2--;y2--;
        rybnik=(int *)malloc(sizeof(int)*m*n);
        for(j=0;j<n;j++)
                for(i=0;i<m;i++)
                        fscanf(f,"%d",&(R(i,j)));
}               

int main(int argc, char **argv)
{
	int x,y,time,maxkroku=0,uzcekam=0;
	char buf[20];
	FILE *f1=fopen(argv[1],"rt");
	FILE *f2=fopen(argv[2],"rt");
	FILE *f3=fopen(argv[3],"rt");
	FILE *f4=stderr;
	if(!f1) {fprintf(f4,"Chyba: neotevreno rybka.in\n"); return 1;}
	if(!f2) {fprintf(f4,"Chyba: neotevreno rybka.ok\n"); return 1;}
	if(!f3) {fprintf(f4,"Chyba: neotevreno rybka.out\n"); return 1;}
	if(!f4) {fprintf(f4,"Chyba: neotevreno stderr\n"); return 1;}
	nacti(f1);
	x=x1;
	y=y1;
	time=0;
	fscanf(f2,"%d",&maxkroku);
	if (maxkroku==0) {fprintf(f4,"Chyba: nenacteno z rybka.ok\n"); return 1;}
	/*je to vubec mozne?*/
	if (maxkroku<0) 
	{
		memset(buf,0,20*sizeof(char));
		fscanf(f3,"%13c",buf);
		if(strcmp(buf,"Chudak Julka!")==0)
		{
			fprintf(f4,"OK (chudinka!)\n"); 
			return 0;
		}
		fprintf(f4,"Marna snaha - Julka nema sanci. (chudinka!)\n"); 
		return 1;
	}
	while((fscanf(f3," %18s ",buf)>0)&&(time<=maxkroku))
	{
		int cek=0;
		if(R(x,y)+time<t1) {fprintf(f4,"Julka umrzla!\n"); return 1;}
		if(R(x,y)+time>t2) {fprintf(f4,"Julka se uvarila!\n"); return 1;}
		uzcekam/=2;
		if(strcmp(buf,"S")==0) y--;
		else if(strcmp(buf,"J")==0) y++;
		else if(strcmp(buf,"V")==0) x++;
		else if(strcmp(buf,"Z")==0) x--;
		else if(sscanf(buf,"%d",&cek)>0) 
		{
			if(uzcekam>0) {fprintf(f4,"Julka ceka dvakrat za sebou!\n"); return 1;}
			if(cek<=0) {fprintf(f4,"Julka ceka nekladnou dobu!\n"); return 1;}
			uzcekam=2;
			time+=cek-1;
		}
		else if (!strcmp(buf, "Chudak")) { fprintf(f4,"Vzdala to predcasne\n"); return 1; }
		else {fprintf(f4,"Neznamy prikaz pro Julku!\n"); return 1;}
		/*okraje*/
		if((x<0)||(x>=m)||(y<0)||(y>=n))
			{fprintf(f4,"Slusne ryby na breh nelezou!\n"); return 1;}
		/*ma nove pole spravnou teplotu?*/
		if((x!=x2)||(y!=y2)){
			if(R(x,y)+time<t1) {fprintf(f4,"Julka umrzla!\n"); return 1;}
			if(R(x,y)+time>t2) {fprintf(f4,"Julka se uvarila!\n"); return 1;}
		}
		/*posun cas - zvys teplotu*/
		time++;
	}
	/*cil?*/
	if((x==x2)&&(y==y2))
	{
		if (time<maxkroku) {fprintf(f4,"OK (zachranena!) (rychleji nez autori!!!! chyba?)\n"); return 0;}
		if (time==maxkroku) {fprintf(f4,"OK (zachranena!)\n"); return 0;}
		fprintf(f4,"Julka cestovala dele nez je potreba!\n"); 
		return 1;
	}
	fprintf(f4,"Julka nedosla do cile! (%d,%d)\n",x,y);
	return 1;
}
